package edu.cosy.JESICA.ControllingMaster;

import edu.cosy.JESICA.Interfaces.*;
import edu.cosy.JESICA.Tools.*;
import java.util.*;

public class AgentCentroidMovement extends Agent 
{
	public AgentCentroidMovement(int nID,IWorldCursor cursor)
	{
		super(nID,cursor);
	}
		
		
		
	int _nUpdateCounter=0;
	
	public static final int _CENTROID_MOVEMENT_THRESHOLD =5;
		
		
	protected void MoveStep()	
	{
		/*
		if(!_bPointAddedToBag) 
		{
			_nUpdateCounter++;
		}
		else
		{
			_nUpdateCounter=0;
		}
		*/
		
		
		if(_WayError.size()<=_CENTROID_MOVEMENT_THRESHOLD)
		{
			super.MoveStep();
			return;
		};
		
		double oldErr=((Double)_WayError.get(_WayError.size()-_CENTROID_MOVEMENT_THRESHOLD-1)).doubleValue();
		
		for(int i= _WayError.size()-_CENTROID_MOVEMENT_THRESHOLD;i<_WayError.size();i++)
		{
			double newErr=((Double)_WayError.get(i)).doubleValue();

			if(newErr-oldErr <= 0)
			{
				super.MoveStep();
				return;
			};
		};
			

		if(_nUpdateCounter<_CENTROID_MOVEMENT_THRESHOLD)
		{
			super.MoveStep();
		}
		
		IWorldPoint[] bag=createPointField(_Way);
		IWorldPoint pt=_cursor.getPoint();
		
		WorldVector sv=null;
		
		for(int i=0;i<bag.length;i++)
		{
			WorldVector v = new WorldVector(pt,bag[i]);
			
			if(sv==null)
			{
				sv=v;
			}
			else
			{
				sv=PointTools.addVector(sv,v);
			};
		};
		
		if(sv==null)
		{
			System.out.println("Error in AgentCentroidMovement::MoveStep: sv was null!");
			super.MoveStep();
			return;
		};
		
		int direction=IWorldCursor.DIRECTION_NUMBERS.NORTH;
		double angle=sv.getAngle();
		
		if(angle >= (-1/8)*Math.PI && angle <(1/8)*Math.PI)
		{
			direction=IWorldCursor.DIRECTION_NUMBERS.EAST;
		}
		else if(angle >= (1/8)*Math.PI && angle < (3/8)*Math.PI)
		{
			direction=IWorldCursor.DIRECTION_NUMBERS.NE;
		}
		else if(angle >= (3/8)*Math.PI && angle < (5/8)*Math.PI)
		{
			direction=IWorldCursor.DIRECTION_NUMBERS.NORTH;
		}
		else if(angle >= (5/8)*Math.PI && angle < (7/8)*Math.PI)
		{
			direction=IWorldCursor.DIRECTION_NUMBERS.NW;
		}
		else if(angle >= (7/8)*Math.PI || angle < -(7/8)*Math.PI)
		{
			direction=IWorldCursor.DIRECTION_NUMBERS.WEST;
		}
		else if(angle < -(5/8)*Math.PI && angle >= -(7/8)*Math.PI)
		{
			direction=IWorldCursor.DIRECTION_NUMBERS.SW;
		}
		else if(angle < -(3/8)*Math.PI && angle >= -(5/8)*Math.PI)
		{
			direction=IWorldCursor.DIRECTION_NUMBERS.SOUTH;
		}
		else if(angle < -(1/8)*Math.PI && angle >= -(3/8)*Math.PI)
		{
			direction=IWorldCursor.DIRECTION_NUMBERS.SE;
		}
			
			
		int gaussdir=Randomizer.randomGauss(8,direction);
			
		System.out.println("Agent " + _nID +" Using error vector movement. angle: " + angle + ", gaussdir: " + gaussdir);	
			
		MoveDirection(gaussdir);
		
	}		


	
}
