package edu.cosy.JESICA.ControllingMaster;
import edu.cosy.JESICA.Interfaces.*;

/** 
 * Discrete x-y world
 */
public class DiscreteWorld implements IWorld 
{
	/** Data points */
	protected DataPoints[] 		_data	= {};
	protected DiscreteWorldRect _rect	= null;
	 
	
	/** 
	 * Get a cursor on the World
	 */
	public IWorldCursor getCursor()
	{
		return new DiscreteWorldCursor(new DiscreteWorldPoint(this));
	}
		
	/**
	 * Get the bounding rect of the world
	 */
	public IWorldRect getBoundingRect()
	{/*
		if(_rect==null)
		{
			_rect=calcRect();
		};
	*/	
		_rect=calcRect();
		return _rect;
	}

	protected DiscreteWorldRect	 calcRect()
	{
		DiscreteWorldRect rect = new DiscreteWorldRect(this);
		
		for(int i=0; i<_data.length;i++)
		{
			rect.enlargeBounding(_data[i].x,_data[i].y);
		};
		
		return rect;
	}
	
	
	public void setData(DataPoints[] data)
	{
		_data=data;
		_rect=calcRect();
	}
	
	
	public void DebugWorld()
	{
		/*
		
		for(int i=0;i<_data.length;i++)
		{
			if(_data[i].d<0.9) System.out.println("Zero point x=" + _data[i].x + " y=" +_data[i].y);
		}
		*/
		
	}
	
}


