package edu.cosy.JESICA.ControllingMaster;

import edu.cosy.JESICA.Interfaces.*;



public class DiscreteWorldRect implements IWorldRect 
{
	protected	transient DiscreteWorld 	_world	= null;
	protected	IWorldPoint					_nw		= null;
	protected	IWorldPoint					_se		= null;
	
	DiscreteWorldRect()
	{

	}
	
	DiscreteWorldRect(DiscreteWorld wrld)
	{
		_world=wrld;
		_nw= new DiscreteWorldPoint(_world);
		_se= new DiscreteWorldPoint(_world);
	}
	
	
	public void setRect(IWorldPoint NWpt, IWorldPoint SWpt) 
	{
		_nw=NWpt;
		_se=SWpt;
		bindWorld(_se.getWorld());
		
	}

	public void enlargeBounding(IWorldPoint pt) 
	{
		if(_world==null) bindWorld(pt.getWorld());
		if(_nw==null) _nw=pt;
		if(_se==null) _se=pt;
		
		if(pt.getX()<_nw.getX()) _nw=new DiscreteWorldPoint(_world,pt.getX(),_nw.getY());
		if(pt.getY()>_nw.getY()) _nw=new DiscreteWorldPoint(_world,_nw.getX(),pt.getY());
		if(pt.getX()>_se.getX()) _se=new DiscreteWorldPoint(_world,pt.getX(),_se.getY());
		if(pt.getY()<_se.getY()) _se=new DiscreteWorldPoint(_world,_se.getX(),pt.getY());
		
	}
	
	public void enlargeBounding(int x, int y) 
	{
		enlargeBounding(new DiscreteWorldPoint(_world,x,y));
	}
	

	public IWorldPoint getNWPoint() 
	{
		return _nw;
	}

	public IWorldPoint getSEPoint() 
	{
		return _se;
	}
	
	
	public IWorldPoint getCenterPoint()
	{
		return new DiscreteWorldPoint(_world,_nw.getX()+getWEDistance()/2, _se.getY()+getNSDistance()/2);
	}
		
	

	public int getNSDistance() 
	{
		
		return _nw.getY()-_se.getY();
	}

	public int getWEDistance() 
	{
		return _se.getX()-_nw.getX();
	}
	
	public boolean isInRect(IWorldPoint point)
	{
		if(point.getX()<_nw.getX()) return false;
		if(point.getX()>_se.getX()) return false;
		if(point.getY()>_nw.getY()) return false;
		if(point.getY()<_se.getY()) return false;
		
		return true;
	}
	
	
	
	public void bindWorld(IWorld wrld) 
	{
		_world=(DiscreteWorld)wrld;
		if(_nw!=null) _nw.bindWorld(_world);
		if(_se!=null) _nw.bindWorld(_world);
	}

	public IWorld getWorld()
	{
		return _world;
	}

}
