package edu.cosy.JESICA.Interfaces;

/** Interface for rectangle in abstract world
 * @author taschaue
 */
public interface IWorldRect extends java.io.Serializable
{
	/**
	 * The cursors binded world
	 */
	//protected IWorld	_world	=null;

	/**
	 * Sets the rect's position at the current world
	 */
	public void	setRect(IWorldPoint NWpt, IWorldPoint SWpt);
	
	/**
	 * Enlarge the rect so that it includes the given point
	 */
	public void	enlargeBounding(IWorldPoint pt);
	
	/**
	 * Returns the North-West end point
	 */
	public IWorldPoint getNWPoint();
	
	/**
	 * Returns the South-East end point
	 */
	public IWorldPoint getSEPoint();
	
	/**
	 * Creates a point representing the center of the rect
	 */
	public IWorldPoint getCenterPoint();

	/**
	 * Returns the North-South distance
	 */
	public int	getNSDistance();
	
	/**
	 * Returns the West-East distance
	 */
	public int	getWEDistance();
	
	
	/**
	 * Test if the given point is in the rect
	 */
	public boolean isInRect(IWorldPoint point);
	
	
	/**
	 * Binds a world after network transmission
	 */
	public void bindWorld(IWorld wrld);

	/**
	 * Returns the currently bounden world
	 */	
	public IWorld getWorld();
	 
}

