package edu.cosy.JESICA.Tools;


public class Randomizer
{
	Randomizer()
	{
	}
	
	// in : value
	// out :  0..value-1
	public	static int	random(int value)
	{
		return ( (int)(Math.random() * ((double)value)) ) ;
	}

	public	static double	randomDouble(double value)
	{
		return ( (Math.random() * value ) ) ;
	}
	
	// in: min,max
	// out: min..max
	public	static int random(int min, int max)
	{
		return min + random((max-min)+1);
	}

	public	static double randomDouble(double min, double max)
	{
		return min + randomDouble((max-min)+1);
	}
	
	// in:  width ( size )
	//		emphasis 
	// out: 
	public	static int randomGauss(int widthIn,int emphasis)
	{	
		double width = ((double)widthIn)/2;
		// get x coordinate for f(x)
		// 0..widthIn
		double x = randomDouble(0, widthIn);
		//System.out.println(" random x: " + x +" gauss(x) = "+gauss(x,width) );
		// get y coordinate
		// 0.0...1.0
		double y = Math.random();
		
		//System.out.println(" random y: " + y +" degauss(y) = "+degauss(y,width) );
				
		
					
		if( y > gauss(x,width) )
		{
			// choose y
			// problem: 2 possible results +- degauss()
			// using randomizer to choose between possible results
			// 0 = leftside ; 1 = rightside; of gauss function
			
			//System.out.println("selected y...");
			x = degauss(y,width); // returns 0..width;
			int r = random(2);
			//if( r == 0 ) System.out.println("left side of gauss function chosen...");
			//else System.out.println("right side of gauss function chosen...");
			x = x + width * r;
		}
		//else System.out.println("selecting x...");
		
		
		//System.out.println(" X = " + Math.round(x) + " " +x);
		
		// emphasis calculation
		//int finalX = (int)Math.round(x);
		
		double emphasedX = x -(width - (double)emphasis);
		//System.out.println(" emphased X = " +emphasedX);
		/*
		if( emphasedX < 0.0 ) 
		{
			emphasedX = emphasedX + ((width*2)) ;
			System.out.println("negative...");
		}
		else
		if( emphasedX >= (double)((width*2)-1) )
		{
			emphasedX = emphasedX - ((width*2)) ;
			System.out.println("positive...");
		}*/
		int finalX = (int)Math.round(emphasedX);
		//System.out.println("rounded X: " +finalX);
		if( finalX < 0 ) 
		{
			finalX = finalX + ((int)width*2) ;
			//System.out.println("negative...");
		}
		else
		if( finalX >= ((width*2)) )
		{
			finalX = finalX - ((int)width*2) ;
			//System.out.println("positive...");
		}
		//System.out.println("Final X = " + emphasedX);
						
		//return (int)Math.round(emphasedX);
		return finalX;
				
	}
	
	public static double degauss(double y, double width) 
	{
		//return width * ( 1 + Math.sqrt( 1 + Math.log(1/y) ) );
		//return width * ( Math.sqrt( 1 + Math.log(1/y) ) );
		return (width*2) - width * ( 1 + Math.sqrt( Math.log(1/y) ) );
		
	}
	
	public static double gauss(double x,double width)
	{
		return Math.exp( -( ((x/width)-1) * ((x/width)-1) ) );		
	}
	

	
}