package edu.cosy.JESICA.Tools;

import edu.cosy.JESICA.Interfaces.*;

public class WorldVector
{
	private	IWorldPoint _ptStart=null;
	private	IWorldPoint _ptEnd=null;
	
	private	double		_dLength=0.0;
	private double		_dAngle=0.0;
	
	private int 		_x=0;
	private int			_y=0;
	
	public WorldVector()
	{
		
	}

	public WorldVector(IWorldPoint ptS, IWorldPoint ptE)
	{
		setVect(ptS,ptE);
	}
	
	
	public void setVect(IWorldPoint ptS, IWorldPoint ptE)
	{
		
		_ptStart=ptS;
		_ptEnd=ptE;
		
		// First calculate vector pt-ptBase
		_x= _ptEnd.getX()-_ptStart.getX();
		_y= _ptEnd.getY()-_ptStart.getY();
		
		// Calc distance		
		_dLength= Math.sqrt(_x*_x+_y*_y);
		
		// Calc agle phi
		_dAngle=Math.atan2(_y,_x);
	}
	
	
	public IWorldPoint getStartPoint()
	{
		return _ptStart;
	}
	
	public IWorldPoint getEndPoint()
	{
		return _ptEnd;
	}
	
	public double getLength()
	{
		return _dLength;
	}
	
	public double getAngle()
	{
		return _dAngle;
	}
	
	
	public int getXDist()
	{
		return _x;
	}
	
	public int getYDist()
	{
		return _y;
	}
	
	
}		
