package edu.cosy.netgen.ann;

import java.beans.*;

/**
 * Provides information of the ANN bean.
 */
public class ANNBeanInfo extends SimpleBeanInfo {
    
    /**
     * Get the descriptor for this bean.
     * <P>
     * @return bean descriptor
     */
    public BeanDescriptor getBeanDescriptor() {      
        BeanDescriptor bd = new BeanDescriptor( ANN.class, ANNBeanWizard.class );
        bd.setDisplayName( "Neuronal Network" );
        return bd;
    }       
    
    /**
     * Get the property descriptors for this bean.
     * <P>
     * @return array of property descriptors
     */
    public PropertyDescriptor[] getPropertyDescriptors() {
        try {
            PropertyDescriptor pd1 = new PropertyDescriptor( "Fitness Function", ANN.class, "getFitnessFunction", "setFitnessFunction" );
            pd1.setBound( true );
            pd1.setPropertyEditorClass( FitnessFunctionPropertyEditor.class );
            return new PropertyDescriptor[]{ pd1 };
        } catch ( Exception e ) {
            return null;
        }
    }
}
