package edu.cosy.netgen.ann;

/**
 * Abstract class for activation functions.
 */
public abstract class ActFunction implements java.io.Serializable {
        
    /**
     * Computes the activation function.
     * <P>
     * @param value the value to compute
     * @return computed value
     */
    public abstract double actFunction( double value );

    /**
     * Computes the derivation of the activation function.
     * <P> 
     * @param value the value to compute
     * @return computed value
     */
    public abstract double actFunctionDerivation( double value );
            
    /**
     * Simple square function.
     * <P>
     * @param value value to sqare
     * @return sqare of the value
     */
    protected double sqr( double value ) {
        return value * value;
    }
}
