package edu.cosy.netgen.ann;

/**
 * Identity activation function.
 */
public class ActFunctionLinear extends ActFunction {
    
    /**
     * Create a identity activation function.
     */
    public ActFunctionLinear() {        
        super();
    }

    /**
     * Computes the identity activation function. New value is equal the old one.
     * <P> 
     * @param value the value to compute
     * @return new calculated value
     */
    public double actFunction( double value ) {
        return value;
    }

    /**
     * Computes the derivation of the identity activation function, the value is one.
     * <P> 
     * @param value the value to compute
     * @return new calculated value
     */
    public double actFunctionDerivation( double value ) {
        return 1.0;
    }
}
