package edu.cosy.netgen.ann;

/**
 * Sigmoid activation function.
 */
public class ActFunctionSigmoid extends ActFunction {
    
    /**
     * Create a logistic activation function.
     */
    public ActFunctionSigmoid() {
        super();
    }
    
    /**
     * Compute the new value with the sigmoid function.
     * out = 1.0 / ( 1.0 + e^-in )
     * <P>
     * @param value value to compute
     * @return new calculated value
     */
    public double actFunction( double value ) {
        return 1.0 / ( 1.0 + Math.exp( -value ) );
    }

    /**
     * Computes the derivation of the sigmoid activation function.
     * out = in * ( 1.0 - in ) + 0.1
     * <P> 
     * @param value the value to compute
     * @return new calculated value
     */
    public double actFunctionDerivation( double value ) {
        return value * ( 1.0 - value ) + 0.1;
    }
}
