package edu.cosy.netgen.ann;

import java.util.*;

public abstract class Training  implements java.io.Serializable {
    //net structure
    protected NeuralNet nn;

    protected ANN bean;

    protected TrainingParam[] params;

    // pattern set for training
    protected PatternSet trainingSet;
    
    // matrix width
    protected int matrixWidth = 0;

    public Training() {
        super();
    }
    
    //square for double values
    protected double sqr( double d ) {
        return d * d;
    }

    public void setParams( TrainingParam[] value ) throws java.lang.IllegalArgumentException {
        if ( value != null && params.length == value.length )
            params = value;
        else
            throw new IllegalArgumentException();
    }    
    
    public TrainingParam[] getParams() {
        return params;
    }

    public abstract boolean init( NeuralNet nn, PatternSet trainSet );
    public abstract int train( ANN bean );
    public abstract int getValidNetType();
}
