package edu.cosy.netgen.client.management.module;
 
import java.util.Hashtable;

import edu.cosy.netgen.client.management.ServerManager;

public class ModuleManager {
    private ServerManager parent;
    private Hashtable modules;
    
    public ModuleManager( ServerManager p ) {
        super();
        parent = p;
    }
    
    public void addModule( ManagementModule m ) {
        if ( modules == null )
            modules = new Hashtable();
        modules.put( m.getNodeName(), m );
    }
    
    public ManagementModule[] getModuleList() {
        ManagementModule[] retVal = null;
        if ( modules != null && modules.size() > 0 ) {
            retVal = new ManagementModule[ modules.size() ];
            retVal = ( ManagementModule[] ) modules.values().toArray( retVal );
        }
        return retVal;
    }
    
    public boolean loadModule( ManagementModule m ) {
        if ( m != null && parent != null )
            return m.load( parent.getConnectedServer() );
        else
            return false;
    }
    
    public boolean unloadModule( ManagementModule m ) {
        if ( m != null )
            return m.unload();
        else
            return false;
    }
}
