package edu.cosy.netgen.client.management.module;
 
import javax.swing.table.DefaultTableModel;

import edu.cosy.netgen.server.WorkingClientInfo;

public class WorkingClientTableModel extends DefaultTableModel {
    private final String[] columnNames = new String[]{ "Address", "State", "Autostart" };
    private WorkingClientInfo[] workingClients;
    
    public int getColumnCount() {
        return columnNames.length;
    }
    
    public String getColumnName( int column ) {
        return columnNames[ column ];
    }
    
    public void setWorkingClientList( WorkingClientInfo[] clients ) {
        workingClients = clients;
        for ( int i = 0; i < getRowCount(); i++ )
            removeRow( i );
        if ( workingClients != null ) {
            for ( int i = 0; i < workingClients.length; i++ ) {
                addRow( new Object[]{ workingClients[ i ].getAddress().toString(), "", new Boolean( workingClients[ i ].isAutoRunnable() ) } );
            }
        }
    }
    
    public WorkingClientInfo getWorkingClientAtRow( int row ) {
        WorkingClientInfo retVal = null;
        if ( row > -1 && workingClients.length > 0 )
            retVal = workingClients[ row ];
        return retVal;
    }
}
