package edu.cosy.netgen.client.management.ui;
  
import java.awt.Component;
import javax.swing.JTree;
import javax.swing.ToolTipManager;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeSelectionModel;
import javax.swing.tree.TreePath;
import javax.swing.tree.DefaultTreeCellRenderer;

import edu.cosy.netgen.client.management.ServerInfo;
import edu.cosy.netgen.client.management.ModuleInfo;
import edu.cosy.netgen.client.management.module.ManagementModule;

public class ServerManagementTree extends JTree {  
    private DefaultMutableTreeNode root;
    private DefaultTreeModel model;

    class ServerCellRenderer extends DefaultTreeCellRenderer {
        public Component getTreeCellRendererComponent( JTree tree, Object value, boolean sel, boolean expanded,
                                                       boolean leaf, int row, boolean hasFocus) {
            super.getTreeCellRendererComponent( tree, value, sel, expanded, leaf, row, hasFocus );
            DefaultMutableTreeNode node = ( DefaultMutableTreeNode ) value;
            Object info = node.getUserObject();
            if ( ServerInfo.class.isInstance( info ) ) {
                ServerInfo tmp = ( ServerInfo ) info;
                setText( tmp.getAddress().toString() );
                setToolTipText( tmp.getDescription() );
            } else if ( ModuleInfo.class.isInstance( info ) ) {
                ManagementModule tmp = ( ( ModuleInfo ) info ).getModule();
                if ( tmp != null ) {
                    setText( tmp.getNodeName() );
                    setToolTipText( tmp.getDescription() );
                }
            }
            return this;
        }        
    }
            
    public ServerManagementTree() {
        super();
        ToolTipManager.sharedInstance().registerComponent( this );    
        setCellRenderer( new ServerCellRenderer() );
        root = new DefaultMutableTreeNode( "netGen Server" );
        model = new DefaultTreeModel( root );
        setModel( model );
        getSelectionModel().setSelectionMode( TreeSelectionModel.SINGLE_TREE_SELECTION );
        setShowsRootHandles( true ); 
    }
}
