package edu.cosy.netgen.client.service;
 
import java.rmi.server.*;
import java.rmi.RemoteException;

import edu.cosy.netgen.client.NetGenClient;
import edu.cosy.netgen.server.ClientControlCommand;
import edu.cosy.netgen.server.event.ServerEvent;

public class ClientControlServiceImpl extends UnicastRemoteObject implements ClientControlService {
    private NetGenClient client;
    
    public ClientControlServiceImpl( NetGenClient client ) throws RemoteException {        
        super();
        this.client = client;
    }
    
    public boolean processCommand( ClientControlCommand cmd ) {
        if ( client != null )
            return client.processCommand( cmd );
        else    
            return false;
    }
    
    public void eventPerformed( ServerEvent e ) {
        if ( client != null )
            client.eventPerformed( e );
        }
}
