package edu.cosy.netgen.server;
 
import java.net.InetAddress;

import edu.cosy.netgen.client.service.ClientControlService;

public abstract class ClientInfo implements java.io.Serializable {
    public final static int UNKNOWN_CLIENT = 100;
    public final static int WORKING_CLIENT = 101;
    public final static int DESIGN_CLIENT = 102;
    public final static int MANAGEMENT_CLIENT = 103;
        
    private int type = UNKNOWN_CLIENT;
    private transient long sessionID = -1;
    private InetAddress address = null;
    private int port = -1;
    private boolean isConnected = false;
    private transient ClientControlService controlService = null;
    
    public ClientInfo( int type, InetAddress adr ) {
        this( type, adr, -1 );
    }
    
    public ClientInfo( int type, InetAddress adr, int port ) {
        if ( type == WORKING_CLIENT || type == DESIGN_CLIENT || type == MANAGEMENT_CLIENT ) {
            this.type = type;
            address = adr;
            this.port = port;
        }
    }
    
    public int getType() {
        return type;
    }
    
    public void setSessionID( long sid ) {
        sessionID = sid;
    }
    
    public long getSessionID() {
        return sessionID;
    }
    
    public InetAddress getAddress() {
        return address;
    }

    public int getPort() {
        return port;
    }
    
    public void setConnectionState( boolean state ) {
        isConnected = state;
    }
    
    public boolean isConnected() {
        return isConnected;
    }

    public void setControlService( ClientControlService service ) {
        controlService = service;
    }
    
    public ClientControlService getControlService() {
        return controlService;
    }
}
