package edu.cosy.netgen.server;
 
import java.net.InetAddress;

public class WorkingClientInfo extends ClientInfo {
    private String rshPath = "rsh";
    private String addCmds = "-l ssodar";    
    private String javaCmd = "java -mx32M";
    private String javaClient = "edu.cosy.netgen.client.WorkingClient";
    private InetAddress serverAddress = null;
    private int serverPort = -1;
    private boolean isAutoRunnable = false;
    
    public WorkingClientInfo( InetAddress adr, int port ) {
        super( ClientInfo.WORKING_CLIENT, adr, port );
    }
    
    public void setRshPath( String s ) {
        rshPath = s;
    }
    public void setCmds( String s ) {
        addCmds = s;
    }
    public void setJavaCmd( String s ) {
        javaCmd = s;
    }

    public String getRshPath() {
        return rshPath;
    }
    
    public String getCmds() {
        return addCmds;
    }
    
    public String getJavaCmd() {
        return javaCmd;
    }

    public void setServerAddress( InetAddress adr ) {
        serverAddress = adr;
    }
    
    public InetAddress getServerAddress() {
        return serverAddress;
    }
    
    public void setServerPort( int port ) {
        serverPort = port;
    }
    
    public int getServerPort() {
        return serverPort;
    }
    
    public void setAutoRunnable( boolean flag ) {
        isAutoRunnable = flag;
    }
    
    public boolean isAutoRunnable() {
        return isAutoRunnable;
    }

    public String getStartupSequence() {
        StringBuffer retVal = new StringBuffer( rshPath );
        retVal.append( " " ).append( getAddress().getHostAddress() );
        retVal.append( " " ).append( addCmds );
        retVal.append( " " ).append( javaCmd );
        retVal.append( " " ).append( javaClient );
        retVal.append( " " ).append( serverAddress.getHostAddress() ).append( " " );
        retVal.append( serverPort ).append(" ").append( getSessionID() ).append( " " );
        retVal.append( getAddress().getHostAddress() ).append( " " ).append( getPort() );
        return retVal.toString();
    }
}
