package edu.cosy.netgen.server.service;

import java.rmi.server.*;
import java.rmi.RemoteException;
import java.util.*;

import edu.cosy.netgen.ga.*;
import edu.cosy.netgen.server.*;

public class WorkingClientServiceImpl extends UnicastRemoteObject implements WorkingClientService {
    private ClientManager clientManager;
    private Container container;
    private int currentTaskType = -1;
        
    public WorkingClientServiceImpl( ClientManager manager, Container con ) throws RemoteException {
        super();
        clientManager = manager;
        container = con;
    }

    public boolean connect( long sessionID ) {
        if ( clientManager != null )
            return clientManager.connect( sessionID );
        else
            return false;
    }
    
    public long connect( WorkingClientInfo info ) {
        if ( clientManager != null )
            return clientManager.connect( info );
        else
            return -1;
    }

    public boolean disconnect( long sessionID ) {
        if ( clientManager != null )
            return clientManager.disconnect( sessionID );
        else
            return false;
    }
    
    public synchronized void setFitness( int i, double v ) throws RemoteException {
        if ( container != null )
            container.setFitness( i, v );
    }

    public synchronized Individual getNextIndividual() throws RemoteException {
        Individual retVal = null;
        if ( container != null )
            retVal = container.getNextIndividual();
        return retVal;
    }
    
    public synchronized int getCurrentTaskType() {
        if ( container != null )
            return container.getCurrentTaskType();
        else
            return -1;
    }
}
