////////////////////////////////////////////////////////////////////////////////////  
//  
//  Copyright (C) 1996 L.  Patocchi & W.Gander
//
//  This program is free  software;  you can  redistribute  it and/or  modify it
//  under the terms of the GNU General  Public  License as published by the Free
//  Software  Foundation;  either  version 2 of the License, or (at your option)
//  any later version.
//
//  This program is  distributed in the hope that it will be useful, but WITHOUT
//  ANY  WARRANTY;  without  even the implied  warranty  of  MERCHANTABILITY  or
//  FITNESS FOR A PARTICULAR  PURPOSE.  See the GNU General  Public  License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software  Foundation, Inc., 675 Mass
//  Ave, Cambridge, MA 02139, USA.
//
//  Contacts:
//  
//    Project Supervisor
//      W.Hett       hew@info.isbiel.ch
//  
//    Authors
//      W.Gander     gandw@info.isbiel.ch
//      L.Patocchi   patol@info.isbiel.ch
//
//  Documentation can be found at:
//
//      http://www.isbiel.ch/Projects/janet/index.html
//
////////////////////////////////////////////////////////////////////////////////////
//
// File : ModuleTypes.java
//
/*
	jaNet - A Neural Network Toolkit for Java
	-----------------------------------------

	Author :		W.Gander
	Modifications :	09.09.1996
	Filename :		ModuleTypeNames.java

	Description :	Contains the string "Type_of_Module", and a
					class path.

					A list of ModuleTypeNames is shown in the "New"
					module menu. This list is dynamic and can be
					modified in the "Options" file menu.

					Contains the read and write to file methods.


	(c) 1996 Biel School of Engineering

	modifications:
	18.9.1996		L.Patocchi

 */
package jaNet;

import java.io.*;

public class ModuleTypes{

	public String	ModuleTypeName;
	public String	ModuleClassName;


	public ModuleTypes(String modtype, String modpath) {
		ModuleTypeName = modtype;
		ModuleClassName	= modpath;
	}

	public ModuleTypes(ModuleTypes modt) {
		ModuleTypeName = modt.ModuleTypeName;
		ModuleClassName	= modt.ModuleClassName;
	}

	public ModuleTypes(RandomAccessFile raf) throws IOException {
		readModuleType(raf);
	}

	public void writeModuleType(RandomAccessFile raf) throws IOException {
		raf.writeUTF(ModuleTypeName);
		raf.writeUTF(ModuleClassName);
	}

	public void readModuleType(RandomAccessFile raf) throws IOException {
		ModuleTypeName = raf.readUTF();
		ModuleClassName = raf.readUTF();
	}
}
